//
//  ViewController.m
//  UniPay
//
//  Created by zhong howard on 13-3-18.
//  Copyright (c) 2013年 __MyCompanyName__. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()

@end

@implementation ViewController
@synthesize resultsTextView;
@synthesize dataTextView;
@synthesize connectedLabel;
@synthesize txtAPDUData;
@synthesize txtDirectIO;

@synthesize sView;
@synthesize view1;
@synthesize view4;
@synthesize pcControlPanes;
@synthesize prompt_doConnection;
@synthesize prompt_pickApp;


extern int g_IOS_Type;

-(void) appendMessageToResults:(NSString*) message{
    [self.resultsTextView setText:[NSString stringWithFormat:@"%@\n%@", self.resultsTextView.text, message]];
    [self.resultsTextView scrollRangeToVisible:NSMakeRange([self.resultsTextView.text length], 0)];
}

-(void) appendMessageToData:(NSString*) message{
    [self.dataTextView setText:[NSString stringWithFormat:@"%@\n%@", self.dataTextView.text, message]];
    [self.dataTextView scrollRangeToVisible:NSMakeRange([self.dataTextView.text length], 0)];
}

- (IBAction) DoClearLog:(id)sender{
    [self.resultsTextView setText: @""];
    [self.resultsTextView scrollRangeToVisible:NSMakeRange([self.resultsTextView.text length], 0)];
    [self.dataTextView setText: @""];
    [self.dataTextView scrollRangeToVisible:NSMakeRange([self.resultsTextView.text length], 0)];

}





//for return IDTResult type function
-(void) displayUpRet2:(NSString*) operation returnValue: (RETURN_CODE)rt
{
    
    NSString * str = [NSString stringWithFormat:
                      @"%@ ERROR: ID-\"%i\", message: %@.",
                      operation, rt, [[IDT_UniPay sharedController] device_getResponseCodeString:rt]];
    [self appendMessageToResults:str];
    
}

- (IBAction) DoKeyboardOff:(id)sender{
    [sender resignFirstResponder];
}


- (void)alertView:(UIAlertView *)alertView didDismissWithButtonIndex:(NSInteger)buttonIndex{

    
    if (alertView == prompt_doConnection)
    {
        //selected option to start the connection task at the reader attachment prompt
        if (1 == buttonIndex) {
            [self appendMessageToResults: @"Start Connect Task..."];
            [[IDT_UniPay sharedController] device_connectToAudioReader];
            
        }
    }

    
}






#pragma mark - UniPay Delegate methods

- (void) dataInOutMonitor:(NSData*)data  incoming:(BOOL)isIncoming{
    [self appendMessageToData:[NSString stringWithFormat:@"%@: %@",isIncoming?@"IN":@"OUT",data.description]];
}


- (void) plugStatusChange:(BOOL)deviceInserted{
    if (deviceInserted) {
        [self appendMessageToResults: @"device Attached."];
        [prompt_doConnection show];
    }
    else{
        [self appendMessageToResults: @"device removed."];
    }
}

-(void)deviceConnected{
    NSLog(@"Connected --");
    connectedLabel.text = @"Connected";
   [self appendMessageToResults:@"([UniPay sharedController] Connected)"];
}

-(void)deviceDisconnected{
    NSLog(@"DisConnt --");
    connectedLabel.text = @"Disconnect";
    [self appendMessageToResults:@"([UniPay sharedController] Disconnect)"];
}

- (void) swipeMSRData:(IDTMSRData*)cardData{
    NSLog(@"--MSR event Received, Type: %d, data: %@", cardData.event, cardData.encTrack1);
    switch (cardData.event) {
        case EVENT_MSR_CARD_DATA:
        {
            switch (cardData.captureEncodeType) {
                case CAPTURE_ENCODE_TYPE_ISOABA:
                    [self appendMessageToResults:[NSString stringWithFormat:@"Encryption Type: %@", @"ISO/ABA"]];
                    break;
                case CAPTURE_ENCODE_TYPE_AAMVA:
                    [self appendMessageToResults:[NSString stringWithFormat:@"Encryption Type: %@", @"AA/MVA"]];
                    break;

                case CAPTURE_ENCODE_TYPE_Other:
                    [self appendMessageToResults:[NSString stringWithFormat:@"Encryption Type: %@", @"Other"]];
                    break;

                case CAPTURE_ENCODE_TYPE_Raw:
                    [self appendMessageToResults:[NSString stringWithFormat:@"Encryption Type: %@", @"Raw"]];
                    break;

                default:
                    [self appendMessageToResults:[NSString stringWithFormat:@"Encryption Type: %@", @"UNKNOWN"]];

                    break;
            }
            
            [self appendMessageToResults:[NSString stringWithFormat:@"Full card data: %@", cardData.cardData]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Track 1: %@", cardData.track1]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Track 2: %@", cardData.track2]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Track 3: %@", cardData.track3]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Length Track 1: %i", cardData.track1Length]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Length Track 2: %i", cardData.track2Length]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Length Track 3: %i", cardData.track3Length]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Encoded Track 1: %@", cardData.encTrack1.description]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Encoded Track 2: %@", cardData.encTrack2.description]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Encoded Track 3: %@", cardData.encTrack3.description]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Hash Track 1: %@", cardData.hashTrack1.description]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Hash Track 2: %@", cardData.hashTrack2.description]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Hash Track 3: %@", cardData.hashTrack3.description]];
            [self appendMessageToResults:[NSString stringWithFormat:@"KSN: %@", cardData.KSN.description]];
            [self appendMessageToResults:[NSString stringWithFormat:@"\nSessionID: %@",  cardData.sessionID.description]];
            [self appendMessageToResults:[NSString stringWithFormat:@"\nReader Serial Number: %@",  cardData.RSN]];
            [self appendMessageToResults:[NSString stringWithFormat:@"\nRead Status: %2X",  cardData.readStatus]];

            NSLog(@"Track 1: %@", cardData.track1);
            NSLog(@"Track 2: %@", cardData.track2);
            NSLog(@"Track 3: %@", cardData.track3);
            NSLog(@"Encoded Track 1: %@", cardData.encTrack1.description);
            NSLog(@"Encoded Track 2: %@", cardData.encTrack2.description);
            NSLog(@"Encoded Track 3: %@", cardData.encTrack3.description);
            NSLog(@"Hash Track 1: %@", cardData.hashTrack1.description);
            NSLog(@"Hash Track 2: %@", cardData.hashTrack2.description);
            NSLog(@"Hash Track 3: %@", cardData.hashTrack3.description);
            NSLog(@"SessionID: %@", cardData.sessionID.description);
            NSLog(@"nReader Serial Number: %@", cardData.RSN);
            NSLog(@"Read Status: %2X", cardData.readStatus);
            NSLog(@"KSN: %@", cardData.KSN.description);

            return;
        }
            break;
            
        case EVENT_MSR_CANCEL_KEY:
        {
            [self appendMessageToResults:[NSString stringWithFormat:@"(Event) MSR Cancel Key received: %@", cardData.encTrack1]];
            return;
        }
            break;
            
        case EVENT_MSR_BACKSPACE_KEY:
        {
            [self appendMessageToResults:[NSString stringWithFormat:@"(Event) MSR Backspace Key received: %@", cardData.encTrack1]];
            return;
        }
            break;
            
        case EVENT_MSR_ENTER_KEY:
        {
            [self appendMessageToResults:[NSString stringWithFormat:@"(Event) MSR Enter Key received: %@", cardData.encTrack1]];
            return;
        }
            break;
            
        case EVENT_MSR_UNKNOWN:
        {
            [self appendMessageToResults:[NSString stringWithFormat:@"(Event) MSR unknown event, data: %@", cardData.encTrack1]];
            return;
        }
            break;
            
        default:
            break;
    }
}

-(void) eventFunctionICC: (Byte) nICC_Attached{
    NSLog(@"UniPay_EventFunctionICC Return Status Code %2X ",  nICC_Attached);
    [self appendMessageToResults:[NSString stringWithFormat:@"\nUniPay_EventFunctionICC Return Status Code %2X ",  nICC_Attached]];
    
}





-(void) dismissAllAlertViews {
    [prompt_doConnection dismissWithClickedButtonIndex:-1 animated:FALSE];
    [prompt_pickApp dismissWithClickedButtonIndex:-1 animated:FALSE];
}


-(void) showAlertView:(NSString*)msg {
    [self dismissAllAlertViews];
    
    UIAlertView *alertView = [[UIAlertView alloc]
                              initWithTitle:@"uniMag"
                              message:msg
                              delegate:nil
                              cancelButtonTitle:@"Ok"
                              otherButtonTitles:nil];
    [alertView show];
    //[alertView release];
    alertView = nil;
}

#pragma mark - View methods

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    
    //init alert views
    prompt_doConnection = [[UIAlertView alloc]
                           initWithTitle:@"UniPay"
                           message:@"Device detected in headphone jack. Try connecting it?"
                           delegate:self
                           cancelButtonTitle:@"Cancel"
                           otherButtonTitles:@"OK",nil];
    
    prompt_pickApp = [[UIAlertView alloc] initWithTitle:@"Please Select App Index #" message:nil delegate:self cancelButtonTitle:@"Cancel" otherButtonTitles:@"OK",nil];


    
    
    //for iPhone
    if (0 == g_IOS_Type) {
        CGRect frame = self.sView.frame;
        frame.size.width = [UIScreen mainScreen].bounds.size.width;
        CGSize contentSize = frame.size;
        contentSize.width *= 2;
        self.sView.contentSize = contentSize;
        
        // add to scroll view

        
        
        frame.origin.y = 0;
        frame.origin.x = frame.size.width * 1;
        self.view4.frame = frame;
        [self.sView addSubview: self.view4];
        
        frame.origin.y = 0;
        frame.origin.x = frame.size.width * 0;
        self.view1.frame = frame;
        [self.sView addSubview: self.view1];
        
        self.pcControlPanes.numberOfPages = 3;
        self.pcControlPanes.currentPage = 0;
    }

    
    //init object
#ifndef __i386__
    [IDT_UniPay sharedController].delegate = self;
    [[IDT_UniPay sharedController] config_setCmdTimeOutDuration: 4];
#endif

}

- (void)viewDidUnload
{
     [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (void)scrollViewDidScroll:(UIScrollView *)sender {
    if (sender != self.sView)
        return;
    
    //for iPhone
    if (0 == g_IOS_Type) {
        //update UIPageControl object
        CGFloat pageWidth = self.sView.frame.size.width;
        int page = floor((self.sView.contentOffset.x + pageWidth / 2) / pageWidth);
        self.pcControlPanes.currentPage = page;
    }
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
    
    NSLog(@"--viewDidAppear");
    BOOL b = [[IDT_UniPay sharedController] isConnected];
    if(b==YES)
    {
        [self deviceConnected];
        [self appendMessageToResults:@"[[UniPay sharedController] Open Success]"];
    }
    else
    {
        [self deviceDisconnected];
        [self appendMessageToResults:@"[[UniPay sharedController] Open Failed]"];
    }
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
        return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
    } else {
        return YES;
    }
}


#pragma mark - spec methods
- (IBAction) f_getFirm:(id)sender
{    NSString *result;
    RETURN_CODE rt = [[IDT_UniPay sharedController]  device_getFirmwareVersion:&result];
    if (RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults: [NSString stringWithFormat:@"Get FM info:  %@", result]];
    }
    else{
        [self displayUpRet2: @"Get FM info" returnValue: rt];
    }
}

- (IBAction) f_DoTest:(id)sender
{
}

- (IBAction) f_getBatteryVoltage:(id)sender{
    NSString* result;
    RETURN_CODE rt = [[IDT_UniPay sharedController] device_getBatteryVoltage:&result];
    if (RETURN_CODE_DO_SUCCESS == rt)
    {
        
        [self appendMessageToResults: [NSString stringWithFormat:@"Battery Voltage:  %@", result]];
    }
    else{
        [self displayUpRet2: @"Battery Voltage" returnValue: rt];
    }
}


- (IBAction) f_getModelNumber:(id)sender
{
    

    NSString* result;
    RETURN_CODE rt = [[IDT_UniPay sharedController] config_getModelNumber:&result];
    if (RETURN_CODE_DO_SUCCESS == rt)
    {
        
        [self appendMessageToResults: [NSString stringWithFormat:@"Get ModelNumber:  %@", result]];
    }
    else{
        [self displayUpRet2: @"Get ModelNumber" returnValue: rt];
    }
    
}

- (IBAction) f_getSerialNumber:(id)sender
{
    NSString* result;
    RETURN_CODE rt = [[IDT_UniPay sharedController] config_getSerialNumber:&result];
    if (RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults: [NSString stringWithFormat:@"Get Serial Number:  %@", result]];
    }
    else{
        [self displayUpRet2: @"Get Serial Number" returnValue: rt];
    }
}
- (IBAction) f_setSerialNumber:(id)sender
{
    RETURN_CODE rt = [[IDT_UniPay sharedController] config_setSerialNumber:@"1234567890"];
    if (RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults: [NSString stringWithFormat:@"Set Serial Number OK"]];
    }
    else{
        [self displayUpRet2: @"Get Serial Number" returnValue: rt];
    }
}






- (IBAction) f_iccNotifyON:(id)sender{
    RETURN_CODE rt = [[IDT_UniPay sharedController] icc_setICCNotification:true];
    if (RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"f_iccNotifyON: OK."];
    }
    else{
        [self displayUpRet2: @"f_iccNotifyON" returnValue: rt];
    }
}
- (IBAction) f_iccNotifyOFF:(id)sender{
    RETURN_CODE rt = [[IDT_UniPay sharedController] icc_setICCNotification:false];
    if (RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"f_iccNotifyOFF: OK."];
    }
    else{
        [self displayUpRet2: @"f_iccNotifyOFF" returnValue: rt];
    }
}




- (IBAction) f_RebootDevice:(id)sender{
    RETURN_CODE rt = [[IDT_UniPay sharedController] device_rebootDevice];
    if (RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"RebootDevice: OK."];
    }
    else{
        [self displayUpRet2: @"RebootDevice" returnValue: rt];
    }
    
}

- (IBAction) f_DisableMSR:(id)sender{
    RETURN_CODE rt = [[IDT_UniPay sharedController] msr_cancelMSRSwipe];
    if(RETURN_CODE_DO_SUCCESS == rt){
        [self appendMessageToResults:@"DisableMSR: OK."];
    }else
    {
        [self displayUpRet2: @"DisableMSR" returnValue:rt];
    }
}


- (IBAction) f_GetMSR_Format:(id)sender{
    NSString* response;
    RETURN_CODE rt = [[IDT_UniPay sharedController] msr_getSwipeEncryption:&response];
    if(RETURN_CODE_DO_SUCCESS == rt){
        [self appendMessageToResults:[NSString stringWithFormat:@"GetMSR_dataFormat: %@", response]];
        if ([response isEqualToString:@"0"]) [self appendMessageToResults:@"Encrypted with Data Key"];
        if ([response isEqualToString:@"1"]) [self appendMessageToResults:@"Encrypted with PIN Key"];

    }else
    {
        [self displayUpRet2: @"GetMSR_dataFormat" returnValue: rt];
    }
    
}

- (IBAction) f_SetMSR_Format:(id)sender{
    RETURN_CODE rt = [[IDT_UniPay sharedController] msr_setSwipeEncryption:1];
    if(RETURN_CODE_DO_SUCCESS == rt){
        [self appendMessageToResults:@"SetMSR_dataFormat: OK."];
    }else
    {
        [self displayUpRet2: @"SetMSR_dataFormat" returnValue: rt];
    }
}




- (IBAction) f_GetCardDataEncryption:(id)sender{
    NSString* response;
    RETURN_CODE rt = [[IDT_UniPay sharedController] icc_getKeyTypeForICCDUKPT:&response];
    if(RETURN_CODE_DO_SUCCESS == rt){
        [self appendMessageToResults:[NSString stringWithFormat:@"GetCardDataEncryption: %@", response]];
        if ([response isEqualToString:@"1"]) [self appendMessageToResults:@"Encrypted with 3DES"];
        if ([response isEqualToString:@"2"]) [self appendMessageToResults:@"Encrypted with AES"];
        
    }else
    {
        [self displayUpRet2: @"GetCardDataEncryption" returnValue: rt];
    }
    
}

- (IBAction) f_SetCardDataEncryption:(id)sender{
    RETURN_CODE rt = [[IDT_UniPay sharedController] icc_setKeyFormatForICCDUKPT:2];
    if(RETURN_CODE_DO_SUCCESS == rt){
        [self appendMessageToResults:@"SetCardDataEncryption: OK."];
    }else
    {
        [self displayUpRet2: @"SetCardDataEncryption" returnValue: rt];
    }
}


- (IBAction) f_EnableMSR_waitData: (id)sender{

    
    RETURN_CODE rt = [[IDT_UniPay sharedController] msr_startMSRSwipe:0];
    if(RETURN_CODE_DO_SUCCESS == rt){
        [self appendMessageToResults:@"EnableMSR: OK."];
    }else
    {
        [self displayUpRet2: @"EnableMSR" returnValue:rt];
    }
}





- (IBAction) f_GetIccReaderStatus: (id)sender
{
    ICCReaderStatus* response;
    RETURN_CODE rt = [[IDT_UniPay sharedController] icc_getICCReaderStatus:&response];
    if(RETURN_CODE_DO_SUCCESS != rt){
        [self displayUpRet2: @"GetICCReaderStatus" returnValue: rt];
    }
    
        NSString *sta;
        if(response->iccPower)
            sta =@"[ICC Powered]";
        else
            sta = @"[ICC Power not Ready]";
        if(response->cardSeated)
            sta =[NSString stringWithFormat:@"%@,[Card Seated]", sta];
        else
            sta =[NSString stringWithFormat:@"%@,[Card not Seated]", sta];
        
        [self appendMessageToResults:[NSString stringWithFormat:@"%@",sta]];
    


}

- (IBAction) f_IccPowerON: (id)sender{
    NSData* response;
    RETURN_CODE rt = [[IDT_UniPay sharedController] icc_powerOnICC:&response];
    
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:[NSString stringWithFormat:@"ICC Powerd On, data: %@\n%@", response.description, [[NSString alloc] initWithData:response encoding:NSASCIIStringEncoding] ]];
        int lengthp = response.length;
        Byte * Response = (Byte*)[response bytes];
        if (0x90 == Response[lengthp-2])
        {
            [self appendMessageToResults:@" - Success."];
        }
        else
        {
            [self appendMessageToResults:@" - Failed."];
        }
    }else
    {
        [self displayUpRet2: @"ICC Powerd On" returnValue:rt];
    }
    
    return;
}

- (IBAction) f_IccPowerOFF: (id)sender{

    NSString* error;
    RETURN_CODE rt = [[IDT_UniPay sharedController] icc_powerOffICC:&error];
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"ICC PowerOff: OK."];
    }else
    {
        [self displayUpRet2: @"ICC PowerOff" returnValue:rt];
    }
}

-(BOOL) isValidChar:(Byte)byChar{
    if ( ((byChar>(Byte)0x2F) && (byChar<(Byte)0x3A)) //'0' - '9'
        || ((byChar>(Byte)0x40) && (byChar<(Byte)0x47)) //'A' - 'F'
        || ((byChar>(Byte)0x60) && (byChar<(Byte)0x67)) //'a' - 'f'
        )
    {
        return YES;
    }
    return NO;
}


-(NSData*) hexStringToBytes:(NSString*)hexString{
    if (hexString.length<1) {
        return nil;
    }
    
    char tmpCh[1024] = {0};
    int count = 0;
    for (int k=0; k<hexString.length;k++) {
        char c = [hexString characterAtIndex:k];
        if (c == (char)0x20) {
            continue;
        }
        tmpCh[count] = c;
        count++;
    }
    tmpCh[count] = 0;
    
    if (count % 2) {
        return nil;
    }
    
    NSString *temp = [[NSString alloc] initWithUTF8String:tmpCh];
    int m = temp.length % 2;
    if (m>0) {
        return nil;
    }
    
    NSMutableData *result = [[NSMutableData alloc] init];
    unsigned char byte;
    char hexChars[3] = {0};
    for (int i=0; i < (temp.length/2); i++) {
        hexChars[0] = [temp characterAtIndex:i*2];
        hexChars[1] = [temp characterAtIndex:i*2+1];
        
        if (![self isValidChar:hexChars[0]] || ![self isValidChar:hexChars[1]]) {
            return nil;
        }
        byte = strtol(hexChars, NULL, 16);
        [result appendBytes:&byte length:1];
    }
    return [NSData dataWithData:result];
}

- (IBAction) f_DirectIO:(id)sender
{
    [txtDirectIO resignFirstResponder];
    
    NSData *dataBuffer = nil;
    NSString *valueEntered = txtDirectIO.text;
    if (valueEntered.length < 2)
    {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Invalid"
                                                        message:@"input data is invalid."
                                                       delegate:nil
                                              cancelButtonTitle:@"Dismiss"
                                              otherButtonTitles:nil];
        [alert show];
        return;
    }
    else
    {
        dataBuffer = [self hexStringToBytes:valueEntered];
        if (dataBuffer.length<1) {
            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Invalid"
                                                            message:@"input value is invalid."
                                                           delegate:nil
                                                  cancelButtonTitle:@"Dismiss"
                                                  otherButtonTitles:nil];
            [alert show];
            return;
        }
    }
    NSData* response;
    RETURN_CODE rt = [[IDT_UniPay sharedController] device_sendDataCommand:dataBuffer calcLRC:true response:&response];
    if (RETURN_CODE_DO_SUCCESS == rt) {
        [self appendMessageToResults:[NSString stringWithFormat:@"DirectIO Result: %@", response.description]];
        if (3 == response.length) {
            Byte *by1 = (unsigned char*)response.bytes;
            if ( (Byte)0x15 == by1[0]) {
                //RETURN_CODE rt2;
                NSData *nd = [NSData dataWithBytes: &by1[1] length:2];
                NSString *str = [[IDT_UniPay sharedController] device_getResponseCodeString:(((int)&by1[1]*256)+(int)&by1[2])];
                [self appendMessageToResults:[NSString stringWithFormat:@", errCode: %@, errInfo: %@", nd.description, str]];
            }
        }
    }
    else
    {
        [self displayUpRet2: @"DirectIO" returnValue:rt];
    }
}

- (IBAction) f_IccExchangeAPDU: (id)sender{
    [txtAPDUData resignFirstResponder];
    
    NSData *dataBuffer = nil;
    NSString *valueEntered = txtAPDUData.text;
    if (valueEntered.length < 6)
    {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Invalid"
                                                        message:@"input APDU data is invalid."
                                                       delegate:nil
                                              cancelButtonTitle:@"Dismiss"
                                              otherButtonTitles:nil];
        [alert show];
        return;
    }
    else
    {
        dataBuffer = [self hexStringToBytes:valueEntered];
        if (dataBuffer.length<3) {
            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Invalid"
                                                            message:@"input value is invalid."
                                                           delegate:nil
                                                  cancelButtonTitle:@"Dismiss"
                                                  otherButtonTitles:nil];
            [alert show];
            return;
        }
    }
    APDUResponse* response;
    RETURN_CODE rt = [[IDT_UniPay sharedController] icc_exchangeAPDU:dataBuffer encrypted:false response:&response];
    [self displayUpRet2: @"ExchangeAPDU" returnValue:rt];

    
    [self appendMessageToResults:[NSString stringWithFormat:@"ExchangeAPDU Result: Encrypted %@", response.hasEncryption?@"TRUE":@"FALSE" ]];
    [self appendMessageToResults:[NSString stringWithFormat:@"ExchangeAPDU Result: APDU %@", response.response.description ]];
    [self appendMessageToResults:[NSString stringWithFormat:@"ExchangeAPDU Result: Has KSN %@", response.hasKSN?@"TRUE":@"FALSE" ]];
    [self appendMessageToResults:[NSString stringWithFormat:@"ExchangeAPDU Result: KSN %@", response.ksn.description ]];


}


- (void) sendAPDU:(NSData*)cAPDU{
    APDUResponse* response;
    [[IDT_UniPay sharedController] icc_exchangeAPDU:cAPDU encrypted:false response:&response];
    if (response == nil) {
        return;
    }
}





-(unsigned int) char2hex:(char)c{
	
	switch (c) {
		case '0' ... '9': return c - '0';
		case 'a' ... 'f': return c - 'a' + 10;
		case 'A' ... 'F': return c - 'A' + 10;
		default: return -1;
	}
}

- (NSData *)hexToData:(NSString*)str {   //Example - Pass string that contains characters "30313233", and it will return a data object containing ascii characters "0123"
	if ([str length] == 0) {
		return nil;
	}
	
	unsigned stringIndex=0, resultIndex=0, max=(int)[str length];
	NSMutableData* result = [NSMutableData dataWithLength:(max + 1)/2];
	unsigned char* bytes = [result mutableBytes];
	
	unsigned num_nibbles = 0;
	unsigned char byte_value = 0;
	
	for (stringIndex = 0; stringIndex < max; stringIndex++) {
		unsigned int val = [self char2hex:[str characterAtIndex:stringIndex]];
		
		num_nibbles++;
		byte_value = byte_value * 16 + (unsigned char)val;
		if (! (num_nibbles % 2)) {
			bytes[resultIndex++] = byte_value;
			byte_value = 0;
		}
	}
	
	
	//final nibble
	if (num_nibbles % 2) {
		bytes[resultIndex++] = byte_value;
	}
	
	[result setLength:resultIndex];
	
	return result;
}

@end
